/*	
 *	modplay.c
 *
 *	modplay - lncvC[
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Mon Jul  8 06:12:00 JST 2001 Naoyuki Sawa
 *	- 1st [XB
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <piece.h>
#include <s1c33cpu.h>
#include "_allinc2.h"
#include "_mod.h"

/* wlncvC[x̂lnct[`ɂ́A
 * ugccJihttp://www2.tky.3web.ne.jp/~yosshin/jv
 * wModPlug ݊AMOD / XM vC[̃\[Xx𗘗pĒ܂B
 * ҂̋gc OijɊӂ܂B
 * 
 * wModPlug ݊AMOD / XM vC[̃\[Xxq؂t@ĆA
 * ̂ƂłB
 * 	_mod.c
 * 	_mod.h
 * 	.TXT
 * ̃t@Cɂ́AؕύXĂ܂B
 */

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define CH		0		/* Đ`l */
#define ATT		0		/* `lʌ */
#define LOOP		0		/* 0:[vȂ/1: */
#define MAX_FILES	((DISP_Y/10)-1)	/* őt@C */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
int errno;				/* bWCug߂ɕKv */
char* err;				/* G[͂ɃbZ[WZbg */
int recover;				/* A\ȃG[H */
char files[MAX_FILES][32];		/* MODt@CXg */
int n_files;				/* MODt@C */
int cursel;				/* ݂̑It@CCfNX */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

int mod_play(int ch, const char* fname, int loop);
void mod_stop();

/****************************************************************************
 *	pceAppInit
 ****************************************************************************/

void
pceAppInit()
{
	int retval, len;
	FILEINFO fi;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceLCDDispStart();

	/* MODt@CT܂B */
	retval = pceFileFindOpen(&fi);
	if(retval != 0) {
		err = "pceFileFindOpen failed";
		recover = 0;
		return;
	}
	while(n_files < MAX_FILES) {
		retval = pceFileFindNext(&fi);
		if(!retval) break; /* Ȃ */
		if((len = strlen(fi.filename)) < 4) continue;
		if(strcmp(&fi.filename[len - 4], ".mod") != 0) continue;
		strcpy(files[n_files++], fi.filename);
	}
	pceFileFindClose(&fi);
	if(n_files == 0) {
		err = "MODt@C܂";
		recover = 0;
		return;
	}

	/* `lʌݒ肵܂B */
	pceWaveSetChAtt(CH, ATT);
}

/****************************************************************************
 *	pceAppProc
 ****************************************************************************/

void
pceAppProc(int count)
{
	int retval, pad, i, x, y;

	/* pbhԎ擾ASELECT{^ŏIB */
	pad = pcePadGet();
	if(pad & TRG_SELECT) {
		pceAppReqExit(0);
		return;
	}

	/* ʃNAB */
	memset(vbuff, 0, sizeof vbuff);

	if(err != NULL) {
		/* G[bZ[W\B */
		pceFontSetType(0x80);
		pceFontSetTxColor(3);
		pceFontSetBkColor(-1);
		pceFontSetPos(0, 0);
		pceFontPutStr(err);

		/* G[H */
		if(recover) {
			if(pad & (TRG_A | TRG_B)) err = NULL;
		}

	} else {
		/* t@CIύXB */
		if(pad & TRG_UP && 0 < cursel) cursel--;
		if(pad & TRG_DN && cursel < n_files - 1) cursel++;

		/* ĐJnH */
		if(pad & TRG_A) {
			retval = mod_play(CH, files[cursel], LOOP);
			if(retval != 0) {
				if(err == NULL) err = "Đł܂ł";
				recover = 1;
			}
		}

		/* Đ~H */
		if(pad & TRG_B) mod_stop();

		/* t@CXg\B */
		pceFontSetType(0x80);
		x = (DISP_X - 10 * 13) / 2;
		y = 0;
		pceFontSetTxColor(0);
		pceFontSetBkColor(3);
		pceFontSetPos(x, y);
		/*             OPQRSTUVWXOPQ*/
		pceFontPutStr("=====lncvC[=====");
		x = 0;
		y += 10;
		pceFontSetBkColor(0);
		pceFontSetBkColor(-1);
		for(i = 0; i < n_files; i++) {
			if(i == cursel) {
				pceFontSetTxColor(0);
				pceFontSetBkColor(2);
			} else {
				pceFontSetTxColor(3);
				pceFontSetBkColor(-1);
			}
			pceFontSetPos(x, y);
			pceFontPutStr(files[i]);
			y += 10;
		}
	}

	/* ʓ]B */
	pceLCDTrans();
}

/****************************************************************************
 *	pceAppExit
 ****************************************************************************/

void
pceAppExit()
{
	/* mɍĐ~B */
	mod_stop();
}

/****************************************************************************
 *	MODĐ[`
 ****************************************************************************/

#define BLOCKSIZE	4096	/* t@C̃ubNTCY                 */
#define TRAP_HSDMA1	23	/* DMA Ch.1]I荞݃xN^ԍ   */
#define MAXCH		4	/* `lFP/ECEdl                    */
#define BLKN		2	/* ubNFA2ȏBԂ2ŏ[ */
#define BLKS		512	/* ubNTCY(Tv)FA64xN */
#define SAMPLERATE	16000	/* WAVEf[^̃Tv[g               */

typedef struct _MODINFO {
	PCEKSENT old_isr;	/* +0,4:̃TEh荞݃[`       */
	volatile char busy;	/* +4,1:mod_fill()ē֎~tO           */
	volatile char bc;	/* +5,1:󂫃ubN                     */
	         char bi;	/* +6,1:󂫃ubN̐擪CfNX       */
	         char ch;	/* +7,1:Đ`l                       */
	/* MOD֘A */
	MOD* m;			/* MODRo[^   */
	unsigned long ms[BLKS];	/* MODWJobt@ */
	/* Wave֘A */
	PCEWAVEINFO wi[BLKN];	/* WAVEwb_   */
	short wb[BLKN][BLKS];	/* WAVEf[^   */
} MODINFO;
static MODINFO mod_info;

static void mod_isr();
static void mod_fill();
static void mod_fill_busy();
static void mod_endproc(PCEWAVEINFO* wi);

int
mod_play(int ch, const char* fname, int loop)
{
	MODINFO* mi = &mod_info;

	int retval, i, ofs;
	const unsigned char* ptr;
	PCEWAVEINFO* wi;
	FILEACC fa;

	/* mɒ~܂B */
	mod_stop();

	/* ŜNA܂B */
	memset(mi, 0, sizeof(MODINFO));

	/* Đ`li[܂B */
	if(ch < 0 || MAXCH - 1 < ch) {
		pceFileClose(&fa);
		MOD__Destruct(mi->m);
		err = "Đ`lsł";
		return -1;
	}
	mi->ch = ch;

	/* MODRo[^쐬܂B */
	mi->m = MOD__Create();
	if(mi->m == NULL) {
		err = "MOD__Create failed";
		return -1;
	}
	retval = MOD__Set_nWavePerSec(mi->m, SAMPLERATE); /* gݒ */
	if(!retval) {
		MOD__Destruct(mi->m);
		err = "MOD__Set_nWavePerSec failed";
		return -1;
	}
	retval = MOD__Set_bLoopMode(mi->m, loop); /* [vݒiĂȂ悤ȁHj */
	if(!retval) {
		MOD__Destruct(mi->m);
		err = "MOD__Set_bLoopMode failed";
		return -1;
	}

	/* t@CJ܂B */
	retval = pceFileOpen(&fa, fname, FOMD_RD);
	if(retval != 0) {
		MOD__Destruct(mi->m);
		err = "t@CJ܂";
		return -1;
	}

	/* ZN^AĂ邱ƂmF܂B */
	ptr = NULL; /* x} */
	for(ofs = 0; ofs < fa.fsize; ofs += BLOCKSIZE) {
		pceFileReadSct(&fa, NULL, ofs / BLOCKSIZE, BLOCKSIZE);
		if(ofs != 0) {
			if(fa.aptr != ptr + BLOCKSIZE) {
				pceFileClose(&fa);
				MOD__Destruct(mi->m);
				err = "t@CsAł\n"
				      "xt@CS\n"
				      "]Ă݂Ă";
				return -1;
			}
		}
		ptr = fa.aptr;
	}

	/* t@Cǂݍ݂܂B */
	pceFileReadSct(&fa, NULL, 0, BLOCKSIZE);
	retval = MOD__LoadSong(mi->m, (void*)fa.aptr, fa.fsize);
	if(!retval) {
		pceFileClose(&fa);
		MOD__Destruct(mi->m);
		err = "Ή̌`A\n"
		      "܂͑傫܂";
		return -1;
	}

	/* t@C܂B */
	pceFileClose(&fa);

	/* WAVE܂B */
	for(i = 0, wi = mi->wi; i < BLKN; i++, wi++) {
		wi->type = PW_TYPE_16BITPCM; /* ւɂ̂PW_TYPE_CONTsv */
		wi->pData = &mi->wb[i][0];
		wi->len = BLKS;
		wi->next = &mi->wi[(i + 1) % BLKN]; /* ւɂ܂ */
		wi->pfEndProc = mod_endproc;
	}

	/* ĐJnOɁASubNɃf[^𖞂Ă܂B */
	mi->bc = BLKN;
	mod_fill();
	mod_fill_busy(); /* RpČx} */

	/* TEh荞݃[`tbNAWaveĐJn܂B
	 * ̓̊ԂɃTEh荞݂Ă͂܂B
	 */
DISABLE;
	mi->old_isr = pceVectorSetTrap(TRAP_HSDMA1, mod_isr);
	pceWaveDataOut(mi->ch, &mi->wi[0]);
ENABLE;

	return 0;
}

void
mod_stop()
{
	MODINFO* mi = &mod_info;

	/* ĐłȂΉ܂B */
	if(mi->old_isr == NULL) return;

	/* WAVEĐ~ATEh荞݃[`ɖ߂܂B
	 * ̓̊ԂɃTEh荞݂Ă͂܂B
	 */
DISABLE;
	pceWaveAbort(mi->ch);
	pceVectorSetTrap(TRAP_HSDMA1, mi->old_isr);
	mi->old_isr = NULL;
ENABLE;

	/* MODRo[^폜܂B */
	MOD__Destruct(mi->m);
}

static void
mod_isr()
{
	/* [%sp+ 0]:psr
	 * [%sp+ 1]:pc
	 */
	asm("
	pushn %r15
	ld.w %r0, %alr
	ld.w %r1, %ahr
	pushn %r1
	");
	/* [%sp+ 0]:alr
	 * [%sp+ 1]:ahr
	 * [%sp+ 2]:r0
	 * [%sp+ 3]:r1
	 * [%sp+ 4]:r2
	 * [%sp+ 5]:r3
	 * [%sp+ 6]:r4
	 * [%sp+ 7]:r5
	 * [%sp+ 8]:r6
	 * [%sp+ 9]:r7
	 * [%sp+10]:r8
	 * [%sp+11]:r9
	 * [%sp+12]:r10
	 * [%sp+13]:r11
	 * [%sp+14]:r12
	 * [%sp+15]:r13
	 * [%sp+16]:r14
	 * [%sp+17]:r15
	 * [%sp+18]:psr
	 * [%sp+19]:pc
	 */
	asm("
	 ld.w %r0, [%sp+18]		; psr
	xld.w %r3, mod_info
	 ld.w %r4, [%r3]+		; old_isr
	xld.w %r1, mod_fill_busy
	xld.w %r2, mod_isr_ret_busy
	btst [%r3], 0			; busy?
	jrne mod_isr_busy
	xld.w %r1, mod_fill
	xld.w %r2, mod_isr_ret
	bset [%r3], 0			; busy <- 1
mod_isr_busy:
	pushn %r2
	");
	/* %r3     :&busy
	 * %r4     :old_isr
	 * [%sp+ 0]:psr
	 * [%sp+ 1]:mod_fill/busy
	 * [%sp+ 2]:mod_isr_ret/busy
	 * [%sp+ 3]:alr
	 * [%sp+ 4]:ahr
	 * [%sp+ 5]:r0
	 * [%sp+ 6]:r1
	 * [%sp+ 7]:r2
	 * [%sp+ 8]:r3
	 * [%sp+ 9]:r4
	 * [%sp+10]:r5
	 * [%sp+11]:r6
	 * [%sp+12]:r7
	 * [%sp+13]:r8
	 * [%sp+14]:r9
	 * [%sp+15]:r10
	 * [%sp+16]:r11
	 * [%sp+17]:r12
	 * [%sp+18]:r13
	 * [%sp+19]:r14
	 * [%sp+20]:r15
	 * [%sp+21]:psr
	 * [%sp+22]:pc
	 */
	asm("
	jp %r4				; * old_isr->(iret)->mod_fill/busy->(ret)->mod_isr_ret/busy
					;   Ԃ̊荞݋֎~h߁Aold_isrretiƂ
					;   荞ݔpsr(ĂIE=1)𕜌Ă܂B
					; * 荞݃[`ł̓tOۑKv̂ŁA
					;   mod_isrAƂretł͂ȂretigȂ΂܂B
					;   ܂A荞ݔpsrA񕜌Ă܂B
mod_isr_ret:
	bclr [%r3], 0			; S1C33̊֐KɂAr3͕ێĂ͂B
mod_isr_ret_busy:
	");
	/* [%sp+ 0]:alr
	 * [%sp+ 1]:ahr
	 * [%sp+ 2]:r0
	 * [%sp+ 3]:r1
	 * [%sp+ 4]:r2
	 * [%sp+ 5]:r3
	 * [%sp+ 6]:r4
	 * [%sp+ 7]:r5
	 * [%sp+ 8]:r6
	 * [%sp+ 9]:r7
	 * [%sp+10]:r8
	 * [%sp+11]:r9
	 * [%sp+12]:r10
	 * [%sp+13]:r11
	 * [%sp+14]:r12
	 * [%sp+15]:r13
	 * [%sp+16]:r14
	 * [%sp+17]:r15
	 * [%sp+18]:psr
	 * [%sp+19]:pc
	 */
	asm("
	popn %r1
	ld.w %ahr, %r1
	ld.w %alr, %r0
	popn %r15
	");
	/* [%sp+ 0]:psr
	 * [%sp+ 1]:pc
	 */
	asm("
	reti
	");
}

static void
mod_fill()
{
	MODINFO* mi = &mod_info;

	int retval, i;
	unsigned long* src, lr;
	short* dst, lf, ri;

	while(mi->bc != 0) {
		/* MODf[^WJ܂B */
		retval = MOD__PlaySong(mi->m, mi->ms, BLKS);
		if(!retval) {
			/* WJɎsAɂ܂B(ĂH) */
			memset(mi->ms, 0, sizeof mi->ms);
		}

		/* EWAVEf[^փRs[܂B */
		src = mi->ms;
		dst = mi->wb[(int)mi->bi];
		for(i = 0; i < BLKS; i++) {
			lr = *src++;
			lf = (short)(lr      );
			ri = (short)(lr >> 16);
			*dst++ = (lf + ri) / 2;
		}

		/* 󂫃ubN̐擪CfNXi߂܂B */
		if(++mi->bi == BLKN) mi->bi = 0;

		/* 󂫃ubN炵܂B
		 * * mod_fill()mod_endproc()Ɋ荞܂\̂ŁA
		 *   u󂫃ubN擾1炷i[v̏̑OŊ荞ݐ䂪KvłB
		 * * mod_isr()oRł̊֐Ă΂ꂽ́A荞݋Ԃ͕sȂ̂ŁA
		 *   PDISABLE/ENABLEł͂ȂAԑޔE֎~EsKv܂B
		 * * 悭lAmod_isr()oRŌĂ΂ꂽ́A荞݋Ɍ܂Ă悤ȋCĂ܂B
		 *   mod_isr()͍DMÅ荞݃nhȂ̂łA
		 *   mod_isr()Ă΂ꂽDMÅ荞݂ꂽ荞݂ĂB
		 * * Ƃ킯ŁAPDISABLE/ENABLEłvm܂B
		 *   ܂AԑޔE֎~EmAȂƂQ͂Ȃ̂ŁÂ܂܂ɂĂ܂B
		 */
		asm("
		pushn %r2
		ld.w %r0, %psr			; %psrۑ
		xand %r1, %r0, 0xffffffef	; 荞݋֎~
		ld.w %psr, %r1
		xld.w %r1, mod_info + 5		; mod_info.bc--
		ld.b %r2, [%r1]
		sub %r2, 1
		ld.b [%r1], %r2
		ld.w %psr, %r0			; %psr
		popn %r2
		");
	}
}

static void
mod_fill_busy()
{
	/* ܂B */
}

static void
mod_endproc(PCEWAVEINFO* wi)
{
	MODINFO* mi = &mod_info;

	/* 󂫃ubN𑝂₵܂B
	 * * PCEWAVEINFO.pfEndProc͊荞݋ԂŌĂ΂܂A
	 *   TEhhCoɂčē֎~Ă̂ŁA
	 *   umi->bc++v̑Oł̊荞ݐ͕Kv܂B
	 * * ē֎~́Asound_isr3()̌㔼ōsĂ܂B
	 *   isnd.c 421`430sQƁABIOS 1.18݁j
	 */
	mi->bc++;
}
